#ifdef INTERFACE
CLASS(VoretServerListTab) EXTENDS(VoretTab)
	METHOD(VoretServerListTab, fill, void(entity))
	ATTRIB(VoretServerListTab, title, string, "Join")
	ATTRIB(VoretServerListTab, intendedWidth, float, 0.9)
	ATTRIB(VoretServerListTab, rows, float, 22)
	ATTRIB(VoretServerListTab, columns, float, 6.5)
ENDCLASS(VoretServerListTab)
entity makeVoretServerListTab();
#endif

#ifdef IMPLEMENTATION

entity makeVoretServerListTab()
{
	entity me;
	me = spawnVoretServerListTab();
	me.configureDialog(me);
	return me;
}
void fillVoretServerListTab(entity me)
{
	entity e, slist, btn;

	slist  = makeVoretServerList();

	me.TR(me);
		me.TD(me, 1, 0.4, e = makeVoretTextLabel(0, "Filter:"));
		me.TD(me, 1, 0.6, btn = makeVoretButton("Clear", '0 0 0'));
			btn.onClick = InputBox_Clear_Click;
		me.TD(me, 1, me.columns - 0.6 * 4 - 0.4, e = makeVoretInputBox(0, string_null));
			e.onChange = ServerList_Filter_Change;
			e.onChangeEntity = slist;
			btn.onClickEntity = e;
			slist.controlledTextbox = e;
		me.TD(me, 1, 0.6, e = makeVoretCheckBox(0, "menu_slist_showempty", "Empty"));
			slist.filterShowEmpty = e.checked;
			e.onClickEntity = slist;
			e.onClick = ServerList_ShowEmpty_Click;
		me.TD(me, 1, 0.6, e = makeVoretCheckBox(0, "menu_slist_showfull", "Full"));
			slist.filterShowFull = e.checked;
			e.onClickEntity = slist;
			e.onClick = ServerList_ShowFull_Click;
		me.TD(me, 1, 0.6, e = makeVoretCheckBox(0, "net_slist_pause", "Pause"));

	me.TR(me);
		me.TD(me, 1, 1, slist.sortButton1 = makeVoretButton(string_null, '0 0 0'));
		me.TD(me, 1, 1, slist.sortButton2 = makeVoretButton(string_null, '0 0 0'));
		me.TD(me, 1, 1, slist.sortButton3 = makeVoretButton(string_null, '0 0 0'));
		me.TD(me, 1, 1, slist.sortButton4 = makeVoretButton(string_null, '0 0 0'));
		me.TD(me, 1, 1, slist.sortButton5 = makeVoretButton(string_null, '0 0 0'));
	me.TR(me);
		me.TD(me, me.rows - 4, me.columns, slist);

	me.gotoRC(me, me.rows - 2, 0);
		me.TD(me, 1, 0.6, e = makeVoretTextLabel(0, "Address:"));
		me.TD(me, 1, 2.9, e = makeVoretInputBox(0, string_null));
			e.onEnter = ServerList_Connect_Click;
			e.onEnterEntity = slist;
			slist.ipAddressBox = e;
		me.TD(me, 1, 1.5, e = makeVoretButton("", '0 0 0'));
			e.onClick = ServerList_Favorite_Click;
			e.onClickEntity = slist;
			slist.favoriteButton = e;
		me.TD(me, 1, 1.5, e = makeVoretButton("Info", '0 0 0'));
			e.onClick = ServerList_Info_Click;
			e.onClickEntity = slist;
			slist.infoButton = e;
	me.TR(me);
		//me.TD(me, 1, 2, e = makeVoretModButton("Multiplayer_Join"));
		me.TD(me, 1, me.columns, e = makeVoretButton("Join!", '0 0 0'));
			e.onClick = ServerList_Connect_Click;
			e.onClickEntity = slist;
			slist.connectButton = e;
}
#endif
