#ifdef INTERFACE
CLASS(VoretServerInfoDialog) EXTENDS(VoretDialog)
	METHOD(VoretServerInfoDialog, fill, void(entity))
	METHOD(VoretServerInfoDialog, loadServerInfo, void(entity, float))
	ATTRIB(VoretServerInfoDialog, title, string, "Server Information")
	ATTRIB(VoretServerInfoDialog, color, vector, SKINCOLOR_DIALOG_SERVERINFO)
	ATTRIB(VoretServerInfoDialog, intendedWidth, float, 0.68)
	ATTRIB(VoretServerInfoDialog, rows, float, 11)
	ATTRIB(VoretServerInfoDialog, columns, float, 12)

	ATTRIB(VoretServerInfoDialog, currentServerName, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerCName, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerType, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerMap, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerPlayers, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerNumPlayers, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerNumBots, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerMod, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerVersion, string, string_null)
	ATTRIB(VoretServerInfoDialog, currentServerPing, string, string_null)

	ATTRIB(VoretServerInfoDialog, nameLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, cnameLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, typeLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, mapLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, rawPlayerList, entity, NULL)
	ATTRIB(VoretServerInfoDialog, numPlayersLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, numBotsLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, modLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, versionLabel, entity, NULL)
	ATTRIB(VoretServerInfoDialog, pingLabel, entity, NULL)
ENDCLASS(VoretServerInfoDialog)

float SLIST_FIELD_NAME;
float SLIST_FIELD_CNAME;
float SLIST_FIELD_QCSTATUS;
float SLIST_FIELD_MAP;
float SLIST_FIELD_PLAYERS;
float SLIST_FIELD_NUMHUMANS;
float SLIST_FIELD_MAXPLAYERS;
float SLIST_FIELD_NUMBOTS;
float SLIST_FIELD_MOD;
float SLIST_FIELD_PING;
void Join_Click(entity btn, entity me);
#endif

#ifdef IMPLEMENTATION
void loadServerInfoVoretServerInfoDialog(entity me, float i)
{
	float m;
	string s, typestr, versionstr, numh, maxp;

	SLIST_FIELD_NAME = gethostcacheindexforkey("name");
	me.currentServerName = strzone(gethostcachestring(SLIST_FIELD_NAME, i));
	me.nameLabel.setText(me.nameLabel, me.currentServerName);

	SLIST_FIELD_CNAME = gethostcacheindexforkey("cname");
	me.currentServerCName = strzone(gethostcachestring(SLIST_FIELD_CNAME, i));
	me.cnameLabel.setText(me.cnameLabel, me.currentServerCName);

	SLIST_FIELD_QCSTATUS = gethostcacheindexforkey("qcstatus");
	s = gethostcachestring(SLIST_FIELD_QCSTATUS, i);
	m = tokenizebyseparator(s, ":");
	if(m > 1)
	{
		typestr = argv (0);
		versionstr = argv(1);
	}
	else
	{
		typestr = "N/A";
		versionstr = "N/A";
	}
	me.currentServerType = strzone(typestr);
	me.typeLabel.setText(me.typeLabel, me.currentServerType);


	SLIST_FIELD_MAP = gethostcacheindexforkey("map");
	me.currentServerMap = strzone(gethostcachestring(SLIST_FIELD_MAP, i));
	me.mapLabel.setText(me.mapLabel, me.currentServerMap);

	SLIST_FIELD_PLAYERS = gethostcacheindexforkey("players");
	me.currentServerPlayers = strzone(gethostcachestring(SLIST_FIELD_PLAYERS, i));
	me.rawPlayerList.setPlayerList(me.rawPlayerList, me.currentServerPlayers);

	SLIST_FIELD_NUMHUMANS = gethostcacheindexforkey("numhumans");
	numh = ftos(gethostcachenumber(SLIST_FIELD_NUMHUMANS, i));
	SLIST_FIELD_MAXPLAYERS = gethostcacheindexforkey("maxplayers");
	maxp = ftos(gethostcachenumber(SLIST_FIELD_MAXPLAYERS, i));
	me.currentServerNumPlayers = strzone(strcat(numh,"/",maxp));
	me.numPlayersLabel.setText(me.numPlayersLabel, me.currentServerNumPlayers);

	SLIST_FIELD_NUMBOTS = gethostcacheindexforkey("numbots");
	s = ftos(gethostcachenumber(SLIST_FIELD_NUMBOTS, i));
	me.currentServerNumBots = strzone(s);
	me.numBotsLabel.setText(me.numBotsLabel, me.currentServerNumBots);

	SLIST_FIELD_MOD = gethostcacheindexforkey("mod");
	me.currentServerMod = strzone(gethostcachestring(SLIST_FIELD_MOD, i));
	me.modLabel.setText(me.modLabel, me.currentServerMod);

	me.currentServerVersion = strzone(versionstr);
	me.versionLabel.setText(me.versionLabel, me.currentServerVersion);

	SLIST_FIELD_PING = gethostcacheindexforkey("ping");
	s = ftos(gethostcachenumber(SLIST_FIELD_PING, i));
	me.currentServerPing = strzone(s);
	me.pingLabel.setText(me.pingLabel, me.currentServerPing);
}

void fillVoretServerInfoDialog(entity me)
{
	entity e;
	me.TR(me);
		me.TD(me, 1, me.columns, e = makeVoretTextLabel(0.5, ""));
			e.colorL = SKINCOLOR_SERVERINFO_NAME;
			e.allowCut = 1;
			me.nameLabel = e;
	me.TR(me);
		me.TD(me, 1, me.columns, e = makeVoretTextLabel(0.5, ""));
			e.colorL = SKINCOLOR_SERVERINFO_IP;
			e.allowCut = 1;
			me.cnameLabel = e;

	me.TR(me);
		me.TD(me, 1, 5.5, e = makeVoretTextLabel(0, "Players:"));
	me.TR(me);
		me.TD(me, me.rows - 4, 6, e = makeVoretPlayerList());
			me.rawPlayerList = e;

	me.gotoRC(me, 1, 6.25); me.setFirstColumn(me, me.currentColumn);

	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Type:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.typeLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Map:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.mapLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Players:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.numPlayersLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Bots:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.numBotsLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Mod:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.modLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Version:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.versionLabel = e;
	me.TR(me);
		me.TD(me, 1, 1.75, e = makeVoretTextLabel(0, "Ping:"));
		me.TD(me, 1, 4.0, e = makeVoretTextLabel(0, ""));
			e.allowCut = 1;
			me.pingLabel = e;

	me.gotoRC(me, me.rows - 1, 0);

		me.TD(me, 1, me.columns - 6, e = makeVoretButton("Close", '0 0 0'));
			e.onClick = Dialog_Close;
			e.onClickEntity = me;
		me.TD(me, 1, me.columns - 6, e = makeVoretButton("Join!", '0 0 0'));
			e.onClick = Join_Click;
			e.onClickEntity = me;
}

void Join_Click(entity btn, entity me)
{
	localcmd("connect ", me.currentServerCName, "\n");
}

#endif
