#ifdef INTERFACE
CLASS(VoretHudDialog) EXTENDS(VoretDialog)
	METHOD(VoretHudDialog, toString, string(entity))
	METHOD(VoretHudDialog, fill, void(entity))
	METHOD(VoretHudDialog, showNotify, void(entity))
	ATTRIB(VoretHudDialog, title, string, "Radar, HUD & Waypoints")
	ATTRIB(VoretHudDialog, color, vector, SKINCOLOR_DIALOG_HUD)
	ATTRIB(VoretHudDialog, intendedWidth, float, 0.7)
	ATTRIB(VoretHudDialog, rows, float, 24)
	ATTRIB(VoretHudDialog, columns, float, 4)
ENDCLASS(VoretHudDialog)
#endif

#ifdef IMPLEMENTATION
void showNotifyVoretHudDialog(entity me)
{
        loadAllCvars(me);
}
string toStringVoretHudDialog(entity me)
{
	return "XXX";
}
void fillVoretHudDialog(entity me)
{
	entity e, sl;
	me.TR(me);
		me.TD(me, 1, 4, makeVoretTextLabel(0, "Screen settings:"));
	me.TR(me);
		me.TDempty(me, 0.2);
		sl = makeVoretSlider(0.1, 1, 0.05, "hud_damage");
		me.TD(me, 1, 2, e = makeVoretSliderCheckBox(0, 1, sl, "Splashes:"));
		me.TD(me, 1, 3, sl);
		makeMulti(e, "hud_stomach");
		makeMulti(sl, "hud_stomach");
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 2, e = makeVoretCheckBox(0, "cl_reticle_item_normal", "Zoom reticles"));
		makeMulti(e, "cl_reticle_item_weapon");
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 2, e = makeVoretCheckBox(0, "cl_artwork", "Intermission art & music"));
		makeMulti(e, "cl_intermission");
	me.TR(me);
	me.TR(me);
		me.TD(me, 1, 4, makeVoretTextLabel(0, "HUD settings:"));
	me.TR(me);
	me.TDempty(me, 0.2);
	me.TD(me, 1, 2, e = makeVoretCheckBoxEx(100, 120, "viewsize", "Enable HUD"));
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretCheckBoxEx(100, 110, "viewsize", "Background:"));
			setDependent(e, "viewsize", 0, 100);
		me.TD(me, 1, 3, e = makeVoretSlider(0, 1, 0.01, "sbar_alpha_bg"));
			setDependent(e, "viewsize", 0, 100);
		me.TR(me);
			me.TDempty(me, 0.2);
			me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Default red:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0, 1, 0.01, "sbar_color_bg_r"));
				setDependent(e, "viewsize", 0, 100);
		me.TR(me);
			me.TDempty(me, 0.2);
			me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Default green:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0, 1, 0.01, "sbar_color_bg_g"));
				setDependent(e, "viewsize", 0, 100);
		me.TR(me);
			me.TDempty(me, 0.2);
			me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Default blue:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0, 1, 0.01, "sbar_color_bg_b"));
				setDependent(e, "viewsize", 0, 100);
		me.TR(me);
			me.TDempty(me, 0.2);
			me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Team color:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0.1, 1, 0.01, "sbar_color_bg_team"));
				setDependent(e, "viewsize", 0, 100);
	me.TR(me);
	me.TR(me);
		me.TD(me, 1, 4, makeVoretTextLabel(0, "Radar settings:"));
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Position:"));
		me.TD(me, 1, 1, e = makeVoretRadioButton(1, "cl_teamradar_position", "0 0", "Top left"));
		me.TD(me, 1, 1, e = makeVoretRadioButton(1, "cl_teamradar_position", "0.5 0", "Top middle"));
		me.TD(me, 1, 1, e = makeVoretRadioButton(1, "cl_teamradar_position", "1 0", "Top right"));
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Size:"));
		me.TD(me, 1, 3, e = makeVoretTextSlider("cl_teamradar_size"));
			e.addValue(e, "96x96", "96 96");
			e.addValue(e, "128x96", "128 96");
			e.addValue(e, "128x128", "128 128");
			e.addValue(e, "192x144", "192 144");
			e.addValue(e, "192x192", "192 192");
			e.addValue(e, "256x192", "256 192");
			e.addValue(e, "256x256", "256 256");
			e.configureVoretTextSliderValues(e);
	me.TR(me);
		me.TDempty(me, 0.2);
		sl = makeVoretSlider(0.20, 1, 0.01, "cl_teamradar_background_alpha");
		me.TD(me, 1, 0.8, e = makeVoretSliderCheckBox(-1, 1, sl, "Background:"));
		me.TD(me, 1, 3, sl);
	me.TR(me);
	me.TR(me);
		me.TD(me, 1, 4, makeVoretTextLabel(0, "Waypoint settings:"));
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 3.8, e = makeVoretCheckBox(1, "cl_hidewaypoints", "Show base waypoints"));
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Waypoint scale:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0.5, 1.5, 0.01, "g_waypointsprite_scale"));
				setDependent(e, "cl_hidewaypoints", 0, 0);
	me.TR(me);
 		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Waypoint alpha:"));
			me.TD(me, 1, 3, e = makeVoretSlider(0.1, 1, 0.01, "g_waypointsprite_alpha"));
				setDependent(e, "cl_hidewaypoints", 0, 0);
	me.TR(me);
		me.TDempty(me, 0.2);
		me.TD(me, 1, 0.8, e = makeVoretTextLabel(0, "Show names:"));
		me.TD(me, 1, 3, e = makeVoretTextSlider("cl_shownames"));
			e.addValue(e, "Never", "0");
			e.addValue(e, "Teammates", "1");
			e.addValue(e, "All players", "2");
			e.configureVoretTextSliderValues(e);
	me.gotoRC(me, me.rows - 1, 0);
		me.TD(me, 1, me.columns, e = makeVoretButton("OK", '0 0 0'));
			e.onClick = Dialog_Close;
			e.onClickEntity = me;
}

#endif
