#ifdef INTERFACE
CLASS(VoretWeaponsDialog) EXTENDS(VoretDialog)
	METHOD(VoretWeaponsDialog, toString, string(entity))
	METHOD(VoretWeaponsDialog, fill, void(entity))
	METHOD(VoretWeaponsDialog, showNotify, void(entity))
	ATTRIB(VoretWeaponsDialog, title, string, "Weapon & Crosshair settings")
	ATTRIB(VoretWeaponsDialog, color, vector, SKINCOLOR_DIALOG_WEAPONS)
	ATTRIB(VoretWeaponsDialog, intendedWidth, float, 0.7)
	ATTRIB(VoretWeaponsDialog, rows, float, 20)
	ATTRIB(VoretWeaponsDialog, columns, float, 4)
	ATTRIB(VoretWeaponsDialog, weaponsList, entity, NULL)
ENDCLASS(VoretWeaponsDialog)
#endif

#ifdef IMPLEMENTATION
void showNotifyVoretWeaponsDialog(entity me)
{
        loadAllCvars(me);
}
string toStringVoretWeaponsDialog(entity me)
{
	return me.weaponsList.toString(me.weaponsList);
}
void fillVoretWeaponsDialog(entity me)
{
	entity e, sl;
	float i;

	// Voretournament has one weapon by default, so disable the weapon priority list code
	/*me.TR(me);
		me.TD(me, 1, 4, makeVoretTextLabel(0, "Weapon priority list:"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 9, 3.75, e = me.weaponsList = makeVoretWeaponsList());
	me.gotoRC(me, 10, 0);
		me.TDempty(me, 1.15);
		me.TD(me, 1, 1, e = makeVoretButton("Up", '0 0 0'));
			e.onClick = WeaponsList_MoveUp_Click;
			e.onClickEntity = me.weaponsList;
		me.TD(me, 1, 1, e = makeVoretButton("Down", '0 0 0'));
			e.onClick = WeaponsList_MoveDown_Click;
			e.onClickEntity = me.weaponsList;
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "cl_weaponpriority_useforcycling", "Use priority list for weapon cycling"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "cl_autoswitch", "Auto switch weapons on pickup"));*/

	me.TR(me);
	me.TD(me, 1, 3, makeVoretTextLabel(0, "Weapon crosshair settings:"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1, e = makeVoretTextLabel(0, "Crosshair:"));
		for(i = 1; i <= 10; ++i) {
			me.TDNoMargin(me, 1, 2.5 / 10, e = makeVoretCrosshairButton(3, i), '1 1 0');
		}
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TDempty(me, 1);
		for(i = 11; i <= 20; ++i) {
			me.TDNoMargin(me, 1, 2.5 / 10, e = makeVoretCrosshairButton(3, i), '1 1 0');
		}
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Crosshair Size:"));
		me.TD(me, 1, 2.5, e = makeVoretSlider(0.40, 2, 0.05, "crosshair_size"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Crosshair Alpha:"));
		me.TD(me, 1, 2.5, e = makeVoretSlider(0, 1, 0.01, "crosshair_color_alpha"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Crosshair Red:"));
		me.TD(me, 1, 2.5, e = makeVoretSlider(0, 1, 0.01, "crosshair_color_red"));
		setDependent(e, "crosshair_color_by_health", 0, 0);
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Crosshair Green:"));
		me.TD(me, 1, 2.5, e = makeVoretSlider(0, 1, 0.01, "crosshair_color_green"));
		setDependent(e, "crosshair_color_by_health", 0, 0);
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Crosshair Blue:"));
		me.TD(me, 1, 2.5, e = makeVoretSlider(0, 1, 0.01, "crosshair_color_blue"));
		setDependent(e, "crosshair_color_by_health", 0, 0);
	me.TR(me);
		me.TDempty(me, 0.6);
		me.TD(me, 1, 2, e = makeVoretCheckBox(0, "crosshair_color_by_health", "Colorize by health"));
	me.TR(me);
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 1.25, e = makeVoretTextLabel(0, "Hit test:"));
		me.TD(me, 1, 2.5/3, e = makeVoretRadioButton(2, "crosshair_hittest", "0",    "None"));
		me.TD(me, 1, 2.5/3, e = makeVoretRadioButton(2, "crosshair_hittest", "1",    "TrueAim"));
		me.TD(me, 1, 2.5/3, e = makeVoretRadioButton(2, "crosshair_hittest", "1.25", "Enemies"));
	me.TR(me);
		me.TDempty(me, 0.3);
		sl = makeVoretSlider(0.1, 1, 0.05, "crosshair_unarmed_dim_color");
		me.TD(me, 1, 1.25, e = makeVoretSliderCheckBox(0, 1, sl, "Dim when unarmed:"));
		me.TD(me, 1, 2.5, sl);
		makeMulti(e, "crosshair_unarmed_dim_alpha");
		makeMulti(sl, "crosshair_unarmed_dim_alpha");
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 2, e = makeVoretCheckBoxEx(0.5, 0, "crosshair_pickup", "Crosshair pickup effect"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 2, e = makeVoretCheckBoxEx(0.5, 0, "crosshair_ring_alpha", "Crosshair ammo ring"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 2, e = makeVoretCheckBox(0, "crosshair_swallowindicator", "Crosshair swallow indicator"));
	me.TR(me);
	me.TR(me);
	me.TD(me, 1, 3, makeVoretTextLabel(0, "Weapon model settings:"));
	me.TR(me);
		me.TDempty(me, 0.3);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "r_drawviewmodel", "Draw 1st person weapon model"));
	me.TR(me);
		me.TDempty(me, 0.6);
		me.TD(me, 1, 2, e = makeVoretRadioButton(1, "cl_gunalign", "4", "Left align"));
			setDependent(e, "r_drawviewmodel", 1, 1);
		me.TD(me, 1, 1, e = makeVoretRadioButton(1, "cl_gunalign", "3", "Right align"));
			setDependent(e, "r_drawviewmodel", 1, 1);

	me.gotoRC(me, me.rows - 1, 0);
		me.TD(me, 1, me.columns, e = makeVoretButton("OK", '0 0 0'));
			e.onClick = Dialog_Close;
			e.onClickEntity = me;
}
#endif
