#ifdef INTERFACE
CLASS(VoretInputSettingsTab) EXTENDS(VoretTab)
	METHOD(VoretInputSettingsTab, fill, void(entity))
	ATTRIB(VoretInputSettingsTab, title, string, "Input")
	ATTRIB(VoretInputSettingsTab, intendedWidth, float, 0.9)
	ATTRIB(VoretInputSettingsTab, rows, float, 19)
	ATTRIB(VoretInputSettingsTab, columns, float, 6.5)
ENDCLASS(VoretInputSettingsTab)
entity makeVoretInputSettingsTab();
#endif

#ifdef IMPLEMENTATION
entity makeVoretInputSettingsTab()
{
	entity me;
	me = spawnVoretInputSettingsTab();
	me.configureDialog(me);
	return me;
}
void fillVoretInputSettingsTab(entity me)
{
	entity e;
	entity kb;

	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretTextLabel(0, "Key bindings:"));
	me.TR(me);
		me.TD(me, me.rows - 2, 3, kb = makeVoretKeyBinder());
	me.gotoRC(me, me.rows - 1, 0);
	me.TR(me);
		me.TD(me, 1, 1, e = makeVoretButton("Change key...", '0 0 0'));
			e.onClick = KeyBinder_Bind_Change;
			e.onClickEntity = kb;
			kb.keyGrabButton = e;
		me.TD(me, 1, 1, e = makeVoretButton("Edit...", '0 0 0'));
			e.onClick = KeyBinder_Bind_Edit;
			e.onClickEntity = kb;
			kb.userbindEditButton = e;
			kb.userbindEditDialog = main.userbindEditDialog;
			main.userbindEditDialog.keybindBox = kb;
		me.TD(me, 1, 1, e = makeVoretButton("Clear", '0 0 0'));
			e.onClick = KeyBinder_Bind_Clear;
			e.onClickEntity = kb;

	me.gotoRC(me, 0, 3.5); me.setFirstColumn(me, me.currentColumn);
		me.TD(me, 1, 1, e = makeVoretTextLabel(0, "Sensitivity:"));
		me.TD(me, 1, 2, e = makeVoretSlider(1, 32, 0.2, "sensitivity"));
	me.TR(me);
		me.TD(me, 1, 1, e = makeVoretTextLabel(0, "UI mouse speed:"));
		me.TD(me, 1, 2, e = makeVoretSlider(0.2, 4.0, 0.1, "menu_mouse_speed"));
	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "m_filter", "Mouse filter"));
	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretCheckBox(1.022, "m_pitch", "Invert mouse"));
	me.TR(me);
		if(cvar_type("joy_enable") & CVAR_TYPEFLAG_ENGINE)
			me.TD(me, 1, 3, e = makeVoretCheckBox(0, "joy_enable", "Use joystick input"));
		else if(cvar_type("joystick") & CVAR_TYPEFLAG_ENGINE)
			me.TD(me, 1, 3, e = makeVoretCheckBox(0, "joystick", "Use joystick input"));
	me.TR(me);
		if(cvar_type("vid_dgamouse") & CVAR_TYPEFLAG_ENGINE)
			me.TD(me, 1, 3, e = makeVoretCheckBox(0, "vid_dgamouse", "Turn off OS mouse acceleration"));
		else if(cvar_type("apple_mouse_noaccel") & CVAR_TYPEFLAG_ENGINE)
			me.TD(me, 1, 3, e = makeVoretCheckBox(0, "apple_mouse_noaccel", "Turn off OS mouse acceleration"));
	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "con_closeontoggleconsole", "\"enter console\" also closes"));
	me.TR(me);
		me.TD(me, 1, 1, e = makeVoretTextLabel(0, "Show binds:"));
		me.TD(me, 1, 2, e = makeVoretTextSlider("sbar_showbinds"));
			e.addValue(e, "Actions", "0");
			e.addValue(e, "Bound keys", "1");
			e.addValue(e, "Both", "2");
			e.configureVoretTextSliderValues(e);
	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretCheckBoxEx(2, 0, "cl_showpressedkeys", "Show pressed keys"));
	me.TR(me);
	me.TR(me);
		me.TD(me, 1, 3, e = makeVoretCheckBox(0, "cl_vore_autodigest", "Automatic digestion"));
}
#endif
