#ifdef INTERFACE
CLASS(VoretSlider) EXTENDS(Slider)
	METHOD(VoretSlider, configureVoretSlider, void(entity, float, float, float, string))
	METHOD(VoretSlider, setValue, void(entity, float))
	ATTRIB(VoretSlider, fontSize, float, SKINFONTSIZE_NORMAL)
	ATTRIB(VoretSlider, valueSpace, float, SKINWIDTH_SLIDERTEXT)
	ATTRIB(VoretSlider, image, string, SKINGFX_SLIDER)
	ATTRIB(VoretSlider, tolerance, vector, SKINTOLERANCE_SLIDER)
	ATTRIB(VoretSlider, align, float, 0.5)
	ATTRIB(VoretSlider, color, vector, SKINCOLOR_SLIDER_N)
	ATTRIB(VoretSlider, colorC, vector, SKINCOLOR_SLIDER_C)
	ATTRIB(VoretSlider, colorF, vector, SKINCOLOR_SLIDER_F)
	ATTRIB(VoretSlider, colorD, vector, SKINCOLOR_SLIDER_D)
	ATTRIB(VoretSlider, color2, vector, SKINCOLOR_SLIDER_S)

	ATTRIB(VoretSlider, cvarName, string, string_null)
	METHOD(VoretSlider, loadCvars, void(entity))
	METHOD(VoretSlider, saveCvars, void(entity))

	ATTRIB(VoretSlider, alpha, float, SKINALPHA_TEXT)
	ATTRIB(VoretSlider, disabledAlpha, float, SKINALPHA_DISABLED)
ENDCLASS(VoretSlider)
entity makeVoretSlider(float, float, float, string);
#endif

#ifdef IMPLEMENTATION
entity makeVoretSlider(float theValueMin, float theValueMax, float theValueStep, string theCvar)
{
	entity me;
	me = spawnVoretSlider();
	me.configureVoretSlider(me, theValueMin, theValueMax, theValueStep, theCvar);
	return me;
}
void configureVoretSliderVoretSlider(entity me, float theValueMin, float theValueMax, float theValueStep, string theCvar)
{
	float v, vk, vp;
	v = theValueMin;
	vk = theValueStep;
	vp = theValueStep * 10;
	while(fabs(vp) < fabs(theValueMax - theValueMin) / 40)
		vp *= 10;
	me.configureSliderVisuals(me, me.fontSize, me.align, me.valueSpace, me.image);
	me.configureSliderValues(me, theValueMin, v, theValueMax, theValueStep, vk, vp);
	if(theCvar)
	{
		me.cvarName = theCvar;
		me.loadCvars(me);
		if(tooltipdb >= 0)
			me.tooltip = getZonedTooltipForIdentifier(theCvar);
	}
}
void setValueVoretSlider(entity me, float val)
{
	if(val != me.value)
	{
		me.value = val;
		me.saveCvars(me);
	}
}
void loadCvarsVoretSlider(entity me)
{
	if not(me.cvarName)
		return;

	me.value = cvar(me.cvarName);
}
void saveCvarsVoretSlider(entity me)
{
	if not(me.cvarName)
		return;

	cvar_set(me.cvarName, ftos(me.value));
}
#endif
